/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#ifndef _machine_machparam_
#define _machine_machparam_

#define XPR_TIMESTAMP 0 /* FIXME */

static inline int splx(unsigned short spl)
{
  unsigned short sr;

  asm("movew sr,%0" : "=d" (sr));
  asm("movew %0,sr" : : "d" (spl | (sr & 0xf8ff)));
  return(sr & 0x700);
}

#define spl7() splx(0x700)
#define spl0() splx(0x000)

#define splhigh() spl7()
#define splvm() spl7()
#define spltty() spl7()
#define splimp() spl7()
#define splio() spl7()
#define splsched() spl7()
#define splclock() spl7()
#define splsoftclock() spl7()

#endif /* _machine_machparam_ */
