/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
#ifndef _machine_thread_
#define _machine_thread_

#include <machine/pcb.h>

/* Jump directly to a continuation function after "cleaning" the current kernel stack */
static inline volatile void
call_continuation(volatile void (*continuation)(void))
{
  extern vm_offset_t active_stacks[NCPUS]; /* define it here to avoid include circularities */

  asm volatile("movel %0,sp" : : "r" (STACK_KS(active_stacks[cpu_number()])));
  (*continuation)();
}

/*
 * Alter the thread's state so that a following thread_exception_return
 * will make the thread return 'retval' from a syscall.
 */
#define thread_set_syscall_return(thread,retval) (thread->pcb->user_regs->d0 = (retval))


#define syscall_emulation_sync(task)


#endif _machine_thread_
