/*
 * Copyright (c) 1988 University of Utah.
 * Copyright (c) 1982, 1986, 1990 The Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * the Systems Programming Group of the University of Utah Computer
 * Science Department.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * from: Utah $Hdr: trap.h 1.1 90/07/09$
 *
 *	@(#)trap.h	7.5 (Berkeley) 5/9/91
 */
#ifndef _machine_trap_
#define _machine_trap_

/*
 * Trap codes
 */

#define	T_BUSERR	2
#define	T_ADDRERR	3
#define	T_ILLINST	4
#define	T_ZERODIV	5
#define	T_CHKINST	6
#define	T_TRAPV 	7
#define	T_PRIVINST	8
#define	T_TRACE		9
#define T_EMU1010       10
#define T_EMU1111       11
#define T_COPERR        13

#define T_INT1          25
#define T_INT2          26
#define T_INT3          27
#define T_INT4          28
#define T_INT5          29
#define T_INT6          30
#define T_INT7          31

#define T_SYSCALL       32
#define T_MACH_MSG_REG  33      /* Quick registerized mach_msg_trap entrypoint */

#define T_FLT_BSUN      48
#define T_FLT_INEX      49
#define T_FLT_ZERODIV   50
#define T_FLT_UNFL      51
#define T_FLT_OPERR     52
#define T_FLT_OVFL      53
#define T_FLT_SNAN      54

/*#define	T_USER		0x80		/* user-mode flag or'ed with type */

#endif _machine_trap_
