/*
 * Copyright (c) 1989 by Apollo Computer, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The authors
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the authors be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 *
 * Copyright (c) 1989 Carnegie-Mellon University
 * Copyright (c) 1988 Carnegie-Mellon University
 * Copyright (c) 1987 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 *
 *
 * Bug reports/fixes, comments and enhancements should be sent to:
 *       nawaf@osf.org
 *       Nawaf Bitar
 *       Open Software Foundation
 *       11 Cambridge Center
 *       Cambridge, MA 02142
 *
 * Contributors:  Nawaf Bitar
 *		  Tom Lemaire
 *		  Vidas Neverauskas
 *		  Ed Sharpe
 *
 */
#ifndef _machine_vm_param_
#define _machine_vm_param_

#define BYTE_SIZE	8	/* byte size in bits */

#define PAGE_SIZE_FIXED 1
#define PAGE_SHIFT      13
#define PAGE_SIZE       (1<<PAGE_SHIFT)          /* 8K */


/* Note: These ranges are temporarily hacked to get the kernel and SIM in positive addresses.  */

#ifdef	ASSEMBLER

#define VM_MIN_ADDRESS	        (0x10000000)
#define VM_MAX_ADDRESS          (0x40000000)
#define VM_MIN_KERNEL_ADDRESS   (0x40000000)	/* 3 gigs user - 1 gig kernel */
#define VM_MAX_KERNEL_ADDRESS   (0xffffffff)

#else

#define VM_MIN_ADDRESS	        ((vm_offset_t) 0x10000000)
#define VM_MAX_ADDRESS          ((vm_offset_t) 0x40000000)
#define VM_MIN_KERNEL_ADDRESS   ((vm_offset_t) 0x40000000)	/* 3 gigs user - 1 gig kernel */
#define VM_MAX_KERNEL_ADDRESS   ((vm_offset_t) 0xffffffff)      /*  */

#endif	ASSEMBLER

#define KERNEL_BASE		VM_MIN_KERNEL_ADDRESS	/* where user stack grows down, and kernel starts */
#define KERNEL_STACK_SIZE       8192
#define INTSTACK_SIZE           8192

#endif _machine_vm_param_
