/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#include "machine/vm_param.h"

/* This module must be the first module in the kernel image, and must be
   loaded at the first usable physical memory address.  On entry:

        D0 = total amount of usable physical memory available starting
             at this address;
        D1 = size of chip memory;
        A0 = physical load address;
        A1 = physical end of kernel/SIM, beginning of free physical memory.

   Entered in temporary VM state.  */

.globl _start
_start:
        lea     _intstack+8192,sp
        movel   d1,sp@-
        movel   d0,sp@-
        movel   a1,sp@-
        movel   a0,sp@-
        jbsr    _ami_init
        /* does not return */

.globl _intstack
.comm _intstack,8192  /* INTSTACK_SIZE */
