/*
 * Mach Operating System
 * Copyright (c) 1991,1990,1989 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
/*
 * HISTORY
 * $Log:	csw.s,v $
 * Revision 2.7  91/07/31  18:36:32  dbg
 * 	Fix for ANSI C preprocessor.
 * 	[91/07/30  17:35:16  dbg]
 *
 * Revision 2.6  91/05/14  17:56:56  mrt
 * 	Correcting copyright
 *
 * Revision 2.5  91/05/08  13:35:49  dbg
 * 	Unlock lock with a locked instruction (xchg).
 * 	[91/03/20            dbg]
 *
 * Revision 2.4  91/02/14  14:20:02  mrt
 * 	Changed to new Mach copyright
 * 	[91/02/13  12:15:27  mrt]
 *
 * Revision 2.3  91/01/08  16:46:20  rpd
 * 	Don't use Times - horta doesn't like it for some reason.
 * 	[91/01/06            rpd]
 *
 * Revision 2.2  90/05/03  15:54:37  dbg
 * 	Created.
 * 	[90/02/05            dbg]
 *
 */

/*
 * Suspend the current thread and resume the next one.
 *
 * void cproc_switch(int *cur, int *next, int *lock)
 */
        .globl  _cproc_switch
_cproc_switch:
        moveml  d2-d7/a2-a6,sp@-
        movel   sp@(44+4),a0
        movel   sp,a0@
        movel   sp@(44+8),a1
        movel   sp@(44+12),a2
        movel   a1@,sp
        clrl    a2@
        moveml  sp@+,d2-d7/a2-a6
        rts

/*
 * Create a new stack frame for a 'waiting' thread,
 * save current thread's frame, and switch to waiting thread.
 *
 * void cproc_start_wait(int *cur,
 *			 cproc_t child,
 *			 int stackp,
 *			 int *lock)
 */
        .globl  _cproc_start_wait
_cproc_start_wait:
        moveml  d2-d7/a2-a6,sp@-
        movel   sp@(44+4),a0
        movel   sp,a0@
        movel   sp@(44+8),a1
        movel   sp@(44+16),a3
        movel   sp@(44+12),sp
        clrl    a3@
        movel   a1,sp@-
        jbsr    _cproc_waiting

/*
 * Set up a thread's stack so that when cproc_switch switches to
 * it, it will start up as if it called
 * cproc_body(child)
 *
 * void cproc_prepare(cproc_t child, int *context, int stack)
 */
        .globl  _cproc_prepare
_cproc_prepare:
        movel   sp@(12),a0
        movel   sp@(4),a0@-
        subqw   #4,a0
        movel   #_cproc_body,a0@-
        lea     a0@(-44),a0
        movel   sp@(8),a1
        movel   a0,a1@
        rts

